This product is not supported for your selected Datadog site. ().

Update a campaign

PUT https://api.ap1.datadoghq.com/api/v2/scorecard/campaigns/{campaign_id}https://api.ap2.datadoghq.com/api/v2/scorecard/campaigns/{campaign_id}https://api.datadoghq.eu/api/v2/scorecard/campaigns/{campaign_id}https://api.ddog-gov.com/api/v2/scorecard/campaigns/{campaign_id}https://api.us2.ddog-gov.com/api/v2/scorecard/campaigns/{campaign_id}https://api.datadoghq.com/api/v2/scorecard/campaigns/{campaign_id}https://api.us3.datadoghq.com/api/v2/scorecard/campaigns/{campaign_id}https://api.us5.datadoghq.com/api/v2/scorecard/campaigns/{campaign_id}

Overview

Updates an existing campaign.

OAuth apps require the apm_service_catalog_write, cases_write authorization scope to access this endpoint.

Arguments

Path Parameters

Name

Type

Description

campaign_id [required]

string

Campaign ID or key.

Request

Body Data (required)

Campaign data.

Expand All

Field

Type

Description

data [required]

object

Data for updating a campaign.

attributes [required]

object

Attributes for updating a campaign.

description

string

The description of the campaign.

due_date

date-time

The due date of the campaign.

entity_scope

string

Entity scope query to filter entities for this campaign.

guidance

string

Guidance for the campaign.

key

string

The unique key for the campaign.

name [required]

string

The name of the campaign.

owner_id [required]

string

The UUID of the campaign owner.

rule_ids [required]

[string]

Array of rule IDs associated with this campaign.

start_date [required]

date-time

The start date of the campaign.

status [required]

string

The status of the campaign.

type [required]

enum

The JSON:API type for campaigns. Allowed enum values: campaign

{
  "data": {
    "attributes": {
      "description": "Campaign to improve security posture for Q1 2024.",
      "due_date": "2024-03-31T23:59:59Z",
      "entity_scope": "kind:service AND team:platform",
      "guidance": "Please ensure all services pass the security requirements.",
      "key": "q1-security-2024",
      "name": "Q1 Security Campaign",
      "owner_id": "550e8400-e29b-41d4-a716-446655440000",
      "rule_ids": [
        "q8MQxk8TCqrHnWkx",
        "r9NRyl9UDrsIoXly"
      ],
      "start_date": "2024-01-01T00:00:00Z",
      "status": "in_progress"
    },
    "type": "campaign"
  }
}

Response

OK

Response containing campaign data.

Expand All

Field

Type

Description

data [required]

object

Campaign data.

attributes [required]

object

Campaign attributes.

created_at [required]

date-time

Creation time of the campaign.

description

string

The description of the campaign.

due_date

date-time

The due date of the campaign.

entity_scope

string

Entity scope query to filter entities for this campaign.

guidance

string

Guidance for the campaign.

key [required]

string

The unique key for the campaign.

modified_at [required]

date-time

Time of last campaign modification.

name [required]

string

The name of the campaign.

owner [required]

string

The UUID of the campaign owner.

start_date [required]

date-time

The start date of the campaign.

status [required]

string

The status of the campaign.

id [required]

string

The unique ID of the campaign.

type [required]

enum

The JSON:API type for campaigns. Allowed enum values: campaign

{
  "data": {
    "attributes": {
      "created_at": "2023-12-15T10:30:00Z",
      "description": "Campaign to improve security posture for Q1 2024.",
      "due_date": "2024-03-31T23:59:59Z",
      "entity_scope": "kind:service AND team:platform",
      "guidance": "Please ensure all services pass the security requirements.",
      "key": "q1-security-2024",
      "modified_at": "2024-01-05T14:20:00Z",
      "name": "Q1 Security Campaign",
      "owner": "550e8400-e29b-41d4-a716-446655440000",
      "start_date": "2024-01-01T00:00:00Z",
      "status": "in_progress"
    },
    "id": "c10ODp0VCrrIpXmz",
    "type": "campaign"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Forbidden

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Found

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  ## default
# 

# Path parameters
export campaign_id="c10ODp0VCrrIpXmz"
# Curl command
curl -X PUT "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/scorecard/campaigns/${campaign_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "description": "Campaign to improve security posture for Q1 2024.", "due_date": "2024-03-31T23:59:59Z", "entity_scope": "kind:service AND team:platform", "guidance": "Please ensure all services pass the security requirements.", "key": "q1-security-2024", "name": "Q1 Security Campaign", "owner_id": "550e8400-e29b-41d4-a716-446655440000", "rule_ids": [ "q8MQxk8TCqrHnWkx", "r9NRyl9UDrsIoXly" ], "start_date": "2024-01-01T00:00:00Z", "status": "in_progress" }, "type": "campaign" } } EOF
"""
Update a campaign returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.scorecards_api import ScorecardsApi
from datadog_api_client.v2.model.campaign_type import CampaignType
from datadog_api_client.v2.model.update_campaign_request import UpdateCampaignRequest
from datadog_api_client.v2.model.update_campaign_request_attributes import UpdateCampaignRequestAttributes
from datadog_api_client.v2.model.update_campaign_request_data import UpdateCampaignRequestData
from datetime import datetime
from dateutil.tz import tzutc

body = UpdateCampaignRequest(
    data=UpdateCampaignRequestData(
        attributes=UpdateCampaignRequestAttributes(
            description="Campaign to improve security posture for Q1 2024.",
            due_date=datetime(2024, 3, 31, 23, 59, 59, tzinfo=tzutc()),
            entity_scope="kind:service AND team:platform",
            guidance="Please ensure all services pass the security requirements.",
            key="q1-security-2024",
            name="Q1 Security Campaign",
            owner_id="550e8400-e29b-41d4-a716-446655440000",
            rule_ids=[
                "q8MQxk8TCqrHnWkx",
                "r9NRyl9UDrsIoXly",
            ],
            start_date=datetime(2024, 1, 1, 0, 0, tzinfo=tzutc()),
            status="in_progress",
        ),
        type=CampaignType.CAMPAIGN,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = ScorecardsApi(api_client)
    response = api_instance.update_scorecard_campaign(campaign_id="c10ODp0VCrrIpXmz", body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
# Update a campaign returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::ScorecardsAPI.new

body = DatadogAPIClient::V2::UpdateCampaignRequest.new({
  data: DatadogAPIClient::V2::UpdateCampaignRequestData.new({
    attributes: DatadogAPIClient::V2::UpdateCampaignRequestAttributes.new({
      description: "Campaign to improve security posture for Q1 2024.",
      due_date: "2024-03-31T23:59:59Z",
      entity_scope: "kind:service AND team:platform",
      guidance: "Please ensure all services pass the security requirements.",
      key: "q1-security-2024",
      name: "Q1 Security Campaign",
      owner_id: "550e8400-e29b-41d4-a716-446655440000",
      rule_ids: [
        "q8MQxk8TCqrHnWkx",
        "r9NRyl9UDrsIoXly",
      ],
      start_date: "2024-01-01T00:00:00Z",
      status: "in_progress",
    }),
    type: DatadogAPIClient::V2::CampaignType::CAMPAIGN,
  }),
})
p api_instance.update_scorecard_campaign("c10ODp0VCrrIpXmz", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
// Update a campaign returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"
	"time"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.UpdateCampaignRequest{
		Data: datadogV2.UpdateCampaignRequestData{
			Attributes: datadogV2.UpdateCampaignRequestAttributes{
				Description: datadog.PtrString("Campaign to improve security posture for Q1 2024."),
				DueDate:     datadog.PtrTime(time.Date(2024, 3, 31, 23, 59, 59, 0, time.UTC)),
				EntityScope: datadog.PtrString("kind:service AND team:platform"),
				Guidance:    datadog.PtrString("Please ensure all services pass the security requirements."),
				Key:         datadog.PtrString("q1-security-2024"),
				Name:        "Q1 Security Campaign",
				OwnerId:     "550e8400-e29b-41d4-a716-446655440000",
				RuleIds: []string{
					"q8MQxk8TCqrHnWkx",
					"r9NRyl9UDrsIoXly",
				},
				StartDate: time.Date(2024, 1, 1, 0, 0, 0, 0, time.UTC),
				Status:    "in_progress",
			},
			Type: datadogV2.CAMPAIGNTYPE_CAMPAIGN,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewScorecardsApi(apiClient)
	resp, r, err := api.UpdateScorecardCampaign(ctx, "c10ODp0VCrrIpXmz", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ScorecardsApi.UpdateScorecardCampaign`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ScorecardsApi.UpdateScorecardCampaign`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
// Update a campaign returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ScorecardsApi;
import com.datadog.api.client.v2.model.CampaignResponse;
import com.datadog.api.client.v2.model.CampaignType;
import com.datadog.api.client.v2.model.UpdateCampaignRequest;
import com.datadog.api.client.v2.model.UpdateCampaignRequestAttributes;
import com.datadog.api.client.v2.model.UpdateCampaignRequestData;
import java.time.OffsetDateTime;
import java.util.Arrays;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ScorecardsApi apiInstance = new ScorecardsApi(defaultClient);

    UpdateCampaignRequest body =
        new UpdateCampaignRequest()
            .data(
                new UpdateCampaignRequestData()
                    .attributes(
                        new UpdateCampaignRequestAttributes()
                            .description("Campaign to improve security posture for Q1 2024.")
                            .dueDate(OffsetDateTime.parse("2024-03-31T23:59:59Z"))
                            .entityScope("kind:service AND team:platform")
                            .guidance("Please ensure all services pass the security requirements.")
                            .key("q1-security-2024")
                            .name("Q1 Security Campaign")
                            .ownerId("550e8400-e29b-41d4-a716-446655440000")
                            .ruleIds(Arrays.asList("q8MQxk8TCqrHnWkx", "r9NRyl9UDrsIoXly"))
                            .startDate(OffsetDateTime.parse("2024-01-01T00:00:00Z"))
                            .status("in_progress"))
                    .type(CampaignType.CAMPAIGN));

    try {
      CampaignResponse result = apiInstance.updateScorecardCampaign("c10ODp0VCrrIpXmz", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ScorecardsApi#updateScorecardCampaign");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
// Update a campaign returns "OK" response
use chrono::{DateTime, Utc};
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_scorecards::ScorecardsAPI;
use datadog_api_client::datadogV2::model::CampaignType;
use datadog_api_client::datadogV2::model::UpdateCampaignRequest;
use datadog_api_client::datadogV2::model::UpdateCampaignRequestAttributes;
use datadog_api_client::datadogV2::model::UpdateCampaignRequestData;

#[tokio::main]
async fn main() {
    let body = UpdateCampaignRequest::new(UpdateCampaignRequestData::new(
        UpdateCampaignRequestAttributes::new(
            "Q1 Security Campaign".to_string(),
            "550e8400-e29b-41d4-a716-446655440000".to_string(),
            vec![
                "q8MQxk8TCqrHnWkx".to_string(),
                "r9NRyl9UDrsIoXly".to_string(),
            ],
            DateTime::parse_from_rfc3339("2024-01-01T00:00:00+00:00")
                .expect("Failed to parse datetime")
                .with_timezone(&Utc),
            "in_progress".to_string(),
        )
        .description("Campaign to improve security posture for Q1 2024.".to_string())
        .due_date(
            DateTime::parse_from_rfc3339("2024-03-31T23:59:59+00:00")
                .expect("Failed to parse datetime")
                .with_timezone(&Utc),
        )
        .entity_scope("kind:service AND team:platform".to_string())
        .guidance("Please ensure all services pass the security requirements.".to_string())
        .key("q1-security-2024".to_string()),
        CampaignType::CAMPAIGN,
    ));
    let configuration = datadog::Configuration::new();
    let api = ScorecardsAPI::with_config(configuration);
    let resp = api
        .update_scorecard_campaign("c10ODp0VCrrIpXmz".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Update a campaign returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.ScorecardsApi(configuration);

const params: v2.ScorecardsApiUpdateScorecardCampaignRequest = {
  body: {
    data: {
      attributes: {
        description: "Campaign to improve security posture for Q1 2024.",
        dueDate: new Date(2024, 3, 31, 23, 59, 59, 0),
        entityScope: "kind:service AND team:platform",
        guidance: "Please ensure all services pass the security requirements.",
        key: "q1-security-2024",
        name: "Q1 Security Campaign",
        ownerId: "550e8400-e29b-41d4-a716-446655440000",
        ruleIds: ["q8MQxk8TCqrHnWkx", "r9NRyl9UDrsIoXly"],
        startDate: new Date(2024, 1, 1, 0, 0, 0, 0),
        status: "in_progress",
      },
      type: "campaign",
    },
  },
  campaignId: "c10ODp0VCrrIpXmz",
};

apiInstance
  .updateScorecardCampaign(params)
  .then((data: v2.CampaignResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"